# yamllint disable
# License: MIT (c) GitLab Inc.
# yamllint enable
---
rules:
- id: "python/deserialization/rule-shelve"
  languages:
  - "python"
  message: |
    Avoid using `shelve`, which uses `pickle`, which is known to lead to code
    execution vulnerabilities. When unpickling, the serialized data could be
    manipulated to run arbitrary code. Instead, consider serializing the
    relevant data as JSON or a similar text-based serialization format.
  metadata:
    cwe: "CWE-502"
    owasp: "A8:2017-Insecure Deserialization"
    shortDescription: "Deserialization of Untrusted Data"
  pattern-either:
  - pattern: "shelve.$FUNC(...)"
  severity: "WARNING"
